-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}
M.type = 'auxilliary'
M.relevantDevice = nil

local blinkTimerThreshold_1 = 0.04
local blinkTimerThreshold_2 = 0.08
local blinkTimerThreshold_3 = 0.12
local blinkTimerThreshold_4 = 0.16
local blinkTimerThreshold_5 = 0.20
local blinkTimerThreshold_6 = 0.24
local blinkTimerThreshold_7 = 0.28
local blinkTimerThreshold_8 = 0.32
local blinkTimerThreshold_9 = 0.36
local blinkTimerThreshold_10 = 0.40
local blinkTimerThreshold_11 = 0.44
local blinkTimerThreshold_12 = 0.48
local blinkTimerThreshold_13 = 0.52
local blinkTimerThreshold_14 = 0.56
local blinkTimerThreshold_15 = 0.60
local blinkTimerThreshold_16 = 0.64
local blinkTimerThreshold_17 = 0.68
local blinkTimerThreshold_18 = 0.72
local blinkTimerThreshold_19 = 0.76
local blinkTimerThreshold_20 = 0.80
local blinkTimerThreshold_21 = 0.84
local blinkTimerThreshold_22 = 0.88
local blinkTimerThreshold_23 = 0.92
local blinkTimerThreshold_24 = 0.96
local blinkTimerThreshold_25 = 1.0
local blinkTimerThreshold_26 = 1.04
local blinkTimerThreshold_27 = 1.08
local blinkTimerThreshold_28 = 1.12
local blinkTimerThreshold_29 = 1.16
local blinkTimerThreshold_30 = 1.20
local blinkTimer = 0
local blinkPulse_1 = 0
local blinkPulse_2 = 0

local function init()
	electrics.values['signal_RL_1'] = 0
	electrics.values['signal_RL_2'] = 0
	electrics.values['signal_RL_3'] = 0
	electrics.values['signal_RL_4'] = 0
	electrics.values['signal_RL_5'] = 0
	electrics.values['signal_RL_6'] = 0
	electrics.values['signal_RL_7'] = 0
	electrics.values['signal_RL_8'] = 0
	electrics.values['signal_RL_9'] = 0
	electrics.values['signal_RL_10'] = 0
	electrics.values['signal_RL_11'] = 0
	electrics.values['signal_RL_12'] = 0
	electrics.values['signal_RL_13'] = 0
	electrics.values['signal_RL_14'] = 0
	electrics.values['signal_RL_15'] = 0
	electrics.values['signal_RL_16'] = 0
	electrics.values['signal_RL_17'] = 0
	electrics.values['signal_RL_18'] = 0
	electrics.values['signal_RL_19'] = 0
	electrics.values['signal_RL_20'] = 0
	electrics.values['signal_RL_21'] = 0

	electrics.values['signal_RR_1'] = 0
	electrics.values['signal_RR_2'] = 0
	electrics.values['signal_RR_3'] = 0
	electrics.values['signal_RR_4'] = 0
	electrics.values['signal_RR_5'] = 0
	electrics.values['signal_RR_6'] = 0
	electrics.values['signal_RR_7'] = 0
	electrics.values['signal_RR_8'] = 0
	electrics.values['signal_RR_9'] = 0
	electrics.values['signal_RR_10'] = 0
	electrics.values['signal_RR_11'] = 0
	electrics.values['signal_RR_12'] = 0
	electrics.values['signal_RR_13'] = 0
	electrics.values['signal_RR_14'] = 0
	electrics.values['signal_RR_15'] = 0
	electrics.values['signal_RR_16'] = 0
	electrics.values['signal_RR_17'] = 0
	electrics.values['signal_RR_18'] = 0
	electrics.values['signal_RR_19'] = 0
	electrics.values['signal_RR_20'] = 0
	electrics.values['signal_RR_21'] = 0
	
	electrics.values['lowhighbeam_RL_1'] = 0
	electrics.values['lowhighbeam_RL_2'] = 0
	electrics.values['lowhighbeam_RL_3'] = 0

	electrics.values['lowhighbeam_RR_1'] = 0
	electrics.values['lowhighbeam_RR_2'] = 0
	electrics.values['lowhighbeam_RR_3'] = 0
	
	electrics.values['tneedle'] = 0
	
end

local function generateBlinkPulse(dt)
  blinkTimer = blinkTimer + dt
  if blinkTimer > blinkTimerThreshold_1 then
    blinkPulse_1 = 1
  end
  if blinkTimer > blinkTimerThreshold_2 then
    blinkPulse_2 = 1
  end
  if blinkTimer > blinkTimerThreshold_3 then
    blinkPulse_3 = 1
  end
  if blinkTimer > blinkTimerThreshold_4 then
    blinkPulse_4 = 1
  end
  if blinkTimer > blinkTimerThreshold_5 then
    blinkPulse_5 = 1
  end
  if blinkTimer > blinkTimerThreshold_6 then
    blinkPulse_6 = 1
  end
  if blinkTimer > blinkTimerThreshold_7 then
    blinkPulse_7 = 1
  end
  if blinkTimer > blinkTimerThreshold_8 then
    blinkPulse_8 = 1
  end
  if blinkTimer > blinkTimerThreshold_9 then
    blinkPulse_9 = 1
  end
  if blinkTimer > blinkTimerThreshold_10 then
    blinkPulse_10 = 1
	blinkPulse_1 = 0
  end
  if blinkTimer > blinkTimerThreshold_11 then
    blinkPulse_11 = 1
	blinkPulse_2 = 0
  end
  if blinkTimer > blinkTimerThreshold_12 then
    blinkPulse_12 = 1
	blinkPulse_3 = 0
  end
  if blinkTimer > blinkTimerThreshold_13 then
    blinkPulse_13 = 1
	blinkPulse_4 = 0
  end
  if blinkTimer > blinkTimerThreshold_14 then
    blinkPulse_14 = 1
	blinkPulse_5 = 0
  end
  if blinkTimer > blinkTimerThreshold_15 then
    blinkPulse_15 = 1
	blinkPulse_6 = 0
  end
  if blinkTimer > blinkTimerThreshold_16 then
    blinkPulse_16 = 1
	blinkPulse_7 = 0
  end
  if blinkTimer > blinkTimerThreshold_17 then
    blinkPulse_17 = 1
	blinkPulse_8 = 0
  end
  if blinkTimer > blinkTimerThreshold_18 then
    blinkPulse_18 = 1
	blinkPulse_9 = 0
  end
  if blinkTimer > blinkTimerThreshold_19 then
    blinkPulse_19 = 1
	blinkPulse_10 = 0
  end
  if blinkTimer > blinkTimerThreshold_20 then
    blinkPulse_20 = 1
	blinkPulse_11 = 0
  end
  if blinkTimer > blinkTimerThreshold_21 then
    blinkPulse_21 = 1
	blinkPulse_12 = 0
  end
  if blinkTimer > blinkTimerThreshold_22 then
	blinkPulse_13 = 0
  end
  if blinkTimer > blinkTimerThreshold_23 then
	blinkPulse_14 = 0
  end
  if blinkTimer > blinkTimerThreshold_24 then
	blinkPulse_15 = 0
  end
  if blinkTimer > blinkTimerThreshold_25 then
	blinkPulse_16 = 0
  end
  if blinkTimer > blinkTimerThreshold_26 then
	blinkPulse_17 = 0
  end
  if blinkTimer > blinkTimerThreshold_27 then
	blinkPulse_18 = 0
  end
  if blinkTimer > blinkTimerThreshold_28 then
	blinkPulse_19 = 0
  end
  if blinkTimer > blinkTimerThreshold_29 then
	blinkPulse_20 = 0
  end
  if blinkTimer > blinkTimerThreshold_30 then
	blinkPulse_21 = 0
    blinkTimer = 0
	
  end
end

local function updateGFX(dt)

    local vals = M.values
    generateBlinkPulse(dt)
	
	electrics.values['signal_RL_1'] = (electrics.values["signal_left_input"] == 1 and blinkPulse_1)
	electrics.values['signal_RL_2'] = (electrics.values["signal_left_input"] == 1 and blinkPulse_2)
	electrics.values['signal_RL_3'] = (electrics.values["signal_left_input"] == 1 and blinkPulse_3)
	electrics.values['signal_RL_4'] = (electrics.values["signal_left_input"] == 1 and blinkPulse_4)
	electrics.values['signal_RL_5'] = (electrics.values["signal_left_input"] == 1 and blinkPulse_5)
	electrics.values['signal_RL_6'] = (electrics.values["signal_left_input"] == 1 and blinkPulse_6)
	electrics.values['signal_RL_7'] = (electrics.values["signal_left_input"] == 1 and blinkPulse_7)
	electrics.values['signal_RL_8'] = (electrics.values["signal_left_input"] == 1 and blinkPulse_8)
	electrics.values['signal_RL_9'] = (electrics.values["signal_left_input"] == 1 and blinkPulse_9)
	electrics.values['signal_RL_10'] = (electrics.values["signal_left_input"] == 1 and blinkPulse_10)
	electrics.values['signal_RL_11'] = (electrics.values["signal_left_input"] == 1 and blinkPulse_11)
	electrics.values['signal_RL_12'] = (electrics.values["signal_left_input"] == 1 and blinkPulse_12)
	electrics.values['signal_RL_13'] = (electrics.values["signal_left_input"] == 1 and blinkPulse_13)
	electrics.values['signal_RL_14'] = (electrics.values["signal_left_input"] == 1 and blinkPulse_14)
	electrics.values['signal_RL_15'] = (electrics.values["signal_left_input"] == 1 and blinkPulse_15)
	electrics.values['signal_RL_16'] = (electrics.values["signal_left_input"] == 1 and blinkPulse_16)
	electrics.values['signal_RL_17'] = (electrics.values["signal_left_input"] == 1 and blinkPulse_17)
	electrics.values['signal_RL_18'] = (electrics.values["signal_left_input"] == 1 and blinkPulse_18)
	electrics.values['signal_RL_19'] = (electrics.values["signal_left_input"] == 1 and blinkPulse_19)
	electrics.values['signal_RL_20'] = (electrics.values["signal_left_input"] == 1 and blinkPulse_20)
	electrics.values['signal_RL_21'] = (electrics.values["signal_left_input"] == 1 and blinkPulse_21)
	
	electrics.values['signal_RR_1'] = (electrics.values["signal_right_input"] == 1 and blinkPulse_1)
	electrics.values['signal_RR_2'] = (electrics.values["signal_right_input"] == 1 and blinkPulse_2)
	electrics.values['signal_RR_3'] = (electrics.values["signal_right_input"] == 1 and blinkPulse_3)
	electrics.values['signal_RR_4'] = (electrics.values["signal_right_input"] == 1 and blinkPulse_4)
	electrics.values['signal_RR_5'] = (electrics.values["signal_right_input"] == 1 and blinkPulse_5)
	electrics.values['signal_RR_6'] = (electrics.values["signal_right_input"] == 1 and blinkPulse_6)
	electrics.values['signal_RR_7'] = (electrics.values["signal_right_input"] == 1 and blinkPulse_7)
	electrics.values['signal_RR_8'] = (electrics.values["signal_right_input"] == 1 and blinkPulse_8)
	electrics.values['signal_RR_9'] = (electrics.values["signal_right_input"] == 1 and blinkPulse_9)
	electrics.values['signal_RR_10'] = (electrics.values["signal_right_input"] == 1 and blinkPulse_10)
	electrics.values['signal_RR_11'] = (electrics.values["signal_right_input"] == 1 and blinkPulse_11)
	electrics.values['signal_RR_12'] = (electrics.values["signal_right_input"] == 1 and blinkPulse_12)
	electrics.values['signal_RR_13'] = (electrics.values["signal_right_input"] == 1 and blinkPulse_13)
	electrics.values['signal_RR_14'] = (electrics.values["signal_right_input"] == 1 and blinkPulse_14)
	electrics.values['signal_RR_15'] = (electrics.values["signal_right_input"] == 1 and blinkPulse_15)
	electrics.values['signal_RR_16'] = (electrics.values["signal_right_input"] == 1 and blinkPulse_16)
	electrics.values['signal_RR_17'] = (electrics.values["signal_right_input"] == 1 and blinkPulse_17)
	electrics.values['signal_RR_18'] = (electrics.values["signal_right_input"] == 1 and blinkPulse_18)
	electrics.values['signal_RR_19'] = (electrics.values["signal_right_input"] == 1 and blinkPulse_19)
	electrics.values['signal_RR_20'] = (electrics.values["signal_right_input"] == 1 and blinkPulse_20)
	electrics.values['signal_RR_21'] = (electrics.values["signal_right_input"] == 1 and blinkPulse_21)
	
	if electrics.values["signal_right_input"] == 0 and electrics.values["signal_left_input"] == 0 then
		blinkPulse_1 = 0  
		blinkPulse_2 = 0
		blinkTimer = 0
	end
	
end

M.init = init
M.updateGFX = updateGFX

return M